#!/usr/bin/perl

#########################################################
# Blah.pl                      |             Version: 3 #
#########################################################
# Software: e-blah!            |   Started on: 12/03/01 #
# Software created by: Justin  |   Current Status: Beta #
#########################################################
# Copyrighted 2001-2003  e-blah!                       #
# All Rights Reserved. License Agreement Below          #
# This program is free software; you can redistribute   #
# it and/or modify it under the terms of the license    #
# agreement (more information at URL below).            #
# This program is distributed in the hope that it will  #
# be useful, but WITHOUT ANY WARRANTY; without even the #
# implied warranty of MERCHANTABILITY or FITNESS FOR A  #
# PARTICULAR PURPOSE.  See the GNU General Public       #
# License for more details.                             #
#          License Agreement Located at:                #
#         http://www.eblah.com/?v=license               #
#########################################################
# Download Software from:          http://www.eblah.com #
#                            http://www.sourceforge.net #
#########################################################

$version = '3.1 Beta (<b>Release 13</b>)';
$versioncr = '3.1 Beta';
$theblahver = 11;  # IMPORTANT: Change to update the settings file

$benchmark = 0; # 2 = phpBB style - clean; 3 = phpBB style with extras - clean; 1 = perl style (no extras)
if($benchmark) { # Check CPU Load
	use Benchmark;
	$t0 = new Benchmark;
}

$scripttype = 'pl';  # Change to 'cgi' if your server does not allow 'pl' scripts

use Fcntl ':flock';
use CGI::Carp qw(fatalsToBrowser);
use CGI qw(:standard);

$languagep = "English";
$languages = "./Languages";

require "Settings.pl";  # !! Some Windows servers may require the full DIR to Settings.pl, change accordingly !!

require "$code/QuickCore.pl";
&UFS;
&CheckCookies;

if($settings[26] && -e("$theme/$settings[26].v2")) { require("$theme/$settings[26].v2"); }

require("$languages/$languagep.lng");
require("$languages/$languagep/2.lng");
$language = "$languages/$languagep";
require "$code/Routines.pl";

if($URL{'a'} ne 'bkupstart') { $SIG{__WARN__} = sub{ &error(@_,1); }; }
require "$code/Load.pl";

&LMG; # If this causes problems, move below AL routine
&BoardCheck;
&ClickLog;
&AL;

if(($maintance || (-e "$root/Maintance.lock") || $noguest) || $lockout) { CoreLoad('BoardLock'); &MainLO; }
&Ban;

&LoadBoard;

sub UFS {
	my($query);
	@url = split(/\,/,$ENV{'QUERY_STRING'});
	foreach (@url) {
		($action,$actiondo) = split("=",$_);
		$URL{$action} = $actiondo;
		if($action =~ /\&/) { $blockform = 1; } # Hack attemp?
	}
	if(!$blockform) {
		$form = new CGI;
		foreach $var ($form->param) {
			$output = join(',',$form->param($var));
			if(!$nouselist{$var}) { $FORM{$var} = $output; }
		}
	}
}

sub CoreLoad {
	if(!-e("$code/$_[0].pl")) {
		if(!$surpress) { &error("$gtxt{'loaderror'}\n\n$_[0].pl",1); }
		else { push(@errors,$_[0]); return; }
	}
	require("$code/$_[0].pl");
}

sub LoadBoard {
	if($URL{'v'} eq 'pm') { CoreLoad('PM'); &PMIndex; }
	elsif($URL{'v'} eq 'whereis') { CoreLoad('WhereIs'); &WhereIs; }
	elsif($URL{'v'} eq 'profile') { CoreLoad('Profile'); &Profile; }
	elsif($URL{'v'} eq 'login') { CoreLoad('Login'); &Login; }
	elsif($URL{'v'} eq 'mod') { CoreLoad('Moderate'); &Moderate; }
	elsif($URL{'v'} eq 'register') { CoreLoad('Register'); &Register; }
	elsif($URL{'v'} eq 'admin') { CoreLoad('Admin'); &Admin; }
	elsif($URL{'v'} eq 'post') { CoreLoad('Post'); &Post; }
	elsif($URL{'v'} eq 'ppoll') { CoreLoad('Poll'); &PPoll; }
	elsif($URL{'v'} eq 'display') { CoreLoad('MessageDisplay'); &MessageDisplay; }
	elsif($URL{'v'} eq 'mindex') { CoreLoad('MessageIndex'); &MessageIndex; }
	elsif($URL{'v'} eq 'print') { CoreLoad('Print'); &PrintDisplay; }
	elsif($URL{'v'} eq 'members') { CoreLoad('Members'); &Members; }
	elsif($URL{'v'} eq 'report') { CoreLoad('Report'); &Execute; }
	elsif($URL{'v'} eq 'cal') { CoreLoad('Calendar'); &Cal; }
	elsif($URL{'v'} eq 'download') { CoreLoad('Attach'); &Download; }
	elsif($URL{'v'} eq 'stats') { CoreLoad('Stats'); &Stats; }
	elsif($URL{'v'} eq 'search') { CoreLoad('Search'); &Search; }
	elsif($URL{'v'} eq 'invite') { CoreLoad('Invite'); &Invite; }
	elsif($URL{'v'} eq 'notify') { CoreLoad('Notify'); &Notify; }
	elsif($URL{'v'} eq 'recommend') { CoreLoad('Recommend'); &Recommend; }
	elsif($URL{'v'} eq 'mark') { &Mark; }
	elsif($URL{'v'} eq 'shownews') { CoreLoad('News'); &News; }
	elsif($URL{'v'} eq 'portal') { CoreLoad('Portal'); &Portal; }
	elsif($URL{'m'} && $URL{'b'}) { redirect("$scripturl,v=display,m=$URL{'m'}"); }
	elsif($URL{'b'}) { redirect("$scripturl,v=mindex"); }
		else { CoreLoad('BoardIndex'); &LoadIndex; }
}
1;